# Copyright 2020 The Tekton Authors
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# coding: utf-8

"""
    Tekton

    Tekton Pipeline  # noqa: E501

    The version of the OpenAPI document: v0.17.2
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from tekton_pipeline.configuration import Configuration


class V1beta1PipelineResourceResult(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'key': 'str',
        'resource_name': 'str',
        'resource_ref': 'V1beta1PipelineResourceRef',
        'type': 'str',
        'value': 'str'
    }

    attribute_map = {
        'key': 'key',
        'resource_name': 'resourceName',
        'resource_ref': 'resourceRef',
        'type': 'type',
        'value': 'value'
    }

    def __init__(self, key=None, resource_name=None, resource_ref=None, type=None, value=None, local_vars_configuration=None):  # noqa: E501
        """V1beta1PipelineResourceResult - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._key = None
        self._resource_name = None
        self._resource_ref = None
        self._type = None
        self._value = None
        self.discriminator = None

        self.key = key
        if resource_name is not None:
            self.resource_name = resource_name
        if resource_ref is not None:
            self.resource_ref = resource_ref
        if type is not None:
            self.type = type
        self.value = value

    @property
    def key(self):
        """Gets the key of this V1beta1PipelineResourceResult.  # noqa: E501


        :return: The key of this V1beta1PipelineResourceResult.  # noqa: E501
        :rtype: str
        """
        return self._key

    @key.setter
    def key(self, key):
        """Sets the key of this V1beta1PipelineResourceResult.


        :param key: The key of this V1beta1PipelineResourceResult.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and key is None:  # noqa: E501
            raise ValueError("Invalid value for `key`, must not be `None`")  # noqa: E501

        self._key = key

    @property
    def resource_name(self):
        """Gets the resource_name of this V1beta1PipelineResourceResult.  # noqa: E501


        :return: The resource_name of this V1beta1PipelineResourceResult.  # noqa: E501
        :rtype: str
        """
        return self._resource_name

    @resource_name.setter
    def resource_name(self, resource_name):
        """Sets the resource_name of this V1beta1PipelineResourceResult.


        :param resource_name: The resource_name of this V1beta1PipelineResourceResult.  # noqa: E501
        :type: str
        """

        self._resource_name = resource_name

    @property
    def resource_ref(self):
        """Gets the resource_ref of this V1beta1PipelineResourceResult.  # noqa: E501


        :return: The resource_ref of this V1beta1PipelineResourceResult.  # noqa: E501
        :rtype: V1beta1PipelineResourceRef
        """
        return self._resource_ref

    @resource_ref.setter
    def resource_ref(self, resource_ref):
        """Sets the resource_ref of this V1beta1PipelineResourceResult.


        :param resource_ref: The resource_ref of this V1beta1PipelineResourceResult.  # noqa: E501
        :type: V1beta1PipelineResourceRef
        """

        self._resource_ref = resource_ref

    @property
    def type(self):
        """Gets the type of this V1beta1PipelineResourceResult.  # noqa: E501


        :return: The type of this V1beta1PipelineResourceResult.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this V1beta1PipelineResourceResult.


        :param type: The type of this V1beta1PipelineResourceResult.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def value(self):
        """Gets the value of this V1beta1PipelineResourceResult.  # noqa: E501


        :return: The value of this V1beta1PipelineResourceResult.  # noqa: E501
        :rtype: str
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this V1beta1PipelineResourceResult.


        :param value: The value of this V1beta1PipelineResourceResult.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and value is None:  # noqa: E501
            raise ValueError("Invalid value for `value`, must not be `None`")  # noqa: E501

        self._value = value

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, V1beta1PipelineResourceResult):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, V1beta1PipelineResourceResult):
            return True

        return self.to_dict() != other.to_dict()
